diff -ru extract/pidgin-2.10.11/libpurple/prefs.c libpurple/prefs.c
--- extract/pidgin-2.10.11/libpurple/prefs.c	2014-11-23 11:41:25.000000000 -0500
+++ libpurple/prefs.c	2015-03-19 23:21:15.000000000 -0400
@@ -1390,8 +309,6 @@
 {
 	void *handle = purple_prefs_get_handle();
 
-	prefs_hash = g_hash_table_new_full(g_str_hash, g_str_equal, g_free, NULL);
-
 	purple_prefs_connect_callback(handle, "/", prefs_save_cb, NULL);
 
 	purple_prefs_add_none("/purple");
@@ -1402,34 +319,7 @@
 
 	/* Away */
 	purple_prefs_add_none("/purple/away");
-	purple_prefs_add_string("/purple/away/idle_reporting", "system");
-	purple_prefs_add_bool("/purple/away/away_when_idle", TRUE);
-	purple_prefs_add_int("/purple/away/mins_before_away", 5);
-
-	/* Away -> Auto-Reply */
-	if (!purple_prefs_exists("/purple/away/auto_response/enabled") ||
-	    !purple_prefs_exists("/purple/away/auto_response/idle_only"))
-	{
-		purple_prefs_add_string("/purple/away/auto_reply", "awayidle");
-	}
-	else
-	{
-		if (!purple_prefs_get_bool("/purple/away/auto_response/enabled"))
-		{
-			purple_prefs_add_string("/purple/away/auto_reply", "never");
-		}
-		else
-		{
-			if (purple_prefs_get_bool("/purple/away/auto_response/idle_only"))
-			{
-				purple_prefs_add_string("/purple/away/auto_reply", "awayidle");
-			}
-			else
-			{
-				purple_prefs_add_string("/purple/away/auto_reply", "away");
-			}
-		}
-	}
+	purple_prefs_add_string("/purple/away/auto_reply", "awayidle");
 
 	/* Buddies */
 	purple_prefs_add_none("/purple/buddies");
@@ -1442,7 +332,6 @@
 	purple_prefs_remove("/purple/contact/idle_score");
 
 	purple_prefs_load();
-	purple_prefs_update_old();
 }
 
 void
@@ -1451,15 +340,22 @@
 	if (save_timer != 0)
 	{
 		purple_timeout_remove(save_timer);
-		save_timer = 0;
-		sync_prefs();
+		save_cb(NULL);
 	}
 
 	purple_prefs_disconnect_by_handle(purple_prefs_get_handle());
 
 	prefs_loaded = FALSE;
-	purple_prefs_destroy();
-	g_hash_table_destroy(prefs_hash);
-	prefs_hash = NULL;
+}
 
+void
+purple_prefs_set_ui_ops(PurplePrefsUiOps *ops)
+{
+	prefs_ui_ops = ops;
+}
+
+PurplePrefsUiOps *
+purple_prefs_get_ui_ops(void)
+{
+	return prefs_ui_ops;
 }
diff -ru extract/pidgin-2.10.11/libpurple/prefs.h libpurple/prefs.h
--- extract/pidgin-2.10.11/libpurple/prefs.h	2014-11-23 11:41:25.000000000 -0500
+++ libpurple/prefs.h	2015-03-19 23:21:15.000000000 -0400
@@ -38,6 +38,8 @@
 	PURPLE_PREF_BOOLEAN,     /**< Boolean.         */
 	PURPLE_PREF_INT,         /**< Integer.         */
 	PURPLE_PREF_STRING,      /**< String.          */
+	/* The 3 following types are unused in libpurple,
+	   and not implemented in Instantbird */
 	PURPLE_PREF_STRING_LIST, /**< List of strings. */
 	PURPLE_PREF_PATH,        /**< Path.            */
 	PURPLE_PREF_PATH_LIST    /**< List of paths.   */
@@ -62,11 +64,71 @@
 typedef void (*PurplePrefCallback) (const char *name, PurplePrefType type,
 		gconstpointer val, gpointer data);
 
+
+/** @copydoc _PurplePrefsUiOps */
+typedef struct _PurplePrefsUiOps PurplePrefsUiOps;
+
+
+/**  Prefs UI operations
+ */
+struct _PurplePrefsUiOps
+{
+	void (*add_none)(const char *name);
+	void (*add_bool)(const char *name, gboolean value);
+	void (*add_int)(const char *name, int value);
+	void (*add_string)(const char *name, const char *value);
+
+	void (*set_bool)(const char *name, gboolean value);
+	void (*set_int)(const char *name, int value);
+	void (*set_string)(const char *name, const char *value);
+
+	gboolean (*get_bool)(const char *name);
+	int (*get_int)(const char *name);
+	const char *(*get_string)(const char *name);
+
+	PurplePrefType (*get_type)(const char *name);
+	GList *(*get_children_names)(const char *name);
+
+	gboolean (*exists)(const char *name);
+	void (*remove)(const char *name);
+
+	void (*save)(void);
+
+	void *(*add_observer)(const char *name, gpointer data);
+	void (*remove_observer)(const char *name, void *observer);
+
+	void (*_purple_reserved1)(void);
+	void (*_purple_reserved2)(void);
+	void (*_purple_reserved3)(void);
+	void (*_purple_reserved4)(void);
+};
+
+
 #ifdef __cplusplus
 extern "C" {
 #endif
 
 /**************************************************************************/
+/** @name UI Registration Functions                                       */
+/**************************************************************************/
+/*@{*/
+/**
+ * Sets the UI operations structure to be used for preferences.
+ *
+ * @param ops The UI operations structure.
+ */
+void purple_prefs_set_ui_ops(PurplePrefsUiOps *ops);
+
+/**
+ * Returns the UI operations structure used for preferences.
+ *
+ * @return The UI operations structure in use.
+ */
+PurplePrefsUiOps *purple_prefs_get_ui_ops(void);
+
+/*@}*/
+
+/**************************************************************************/
 /** @name Prefs API
     Preferences are named according to a directory-like structure.
     Example: "/plugins/core/potato/is_from_idaho" (probably a boolean)    */
@@ -122,37 +184,6 @@
 void purple_prefs_add_string(const char *name, const char *value);
 
 /**
- * Add a new string list pref.
- *
- * @param name  The name of the pref
- * @param value The initial value to set
- * @note This function takes a copy of the strings in the value list. The list
- *       itself and original copies of the strings are up to the caller to
- *       free.
- */
-void purple_prefs_add_string_list(const char *name, GList *value);
-
-/**
- * Add a new path pref.
- *
- * @param name  The name of the pref
- * @param value The initial value to set
- */
-void purple_prefs_add_path(const char *name, const char *value);
-
-/**
- * Add a new path list pref.
- *
- * @param name  The name of the pref
- * @param value The initial value to set
- * @note This function takes a copy of the strings in the value list. The list
- *       itself and original copies of the strings are up to the caller to
- *       free.
- */
-void purple_prefs_add_path_list(const char *name, GList *value);
-
-
-/**
  * Remove a pref.
  *
  * @param name The name of the pref
@@ -160,44 +191,6 @@
 void purple_prefs_remove(const char *name);
 
 /**
- * Rename a pref
- *
- * @param oldname The old name of the pref
- * @param newname The new name for the pref
- */
-void purple_prefs_rename(const char *oldname, const char *newname);
-
-/**
- * Rename a boolean pref, toggling it's value
- *
- * @param oldname The old name of the pref
- * @param newname The new name for the pref
- */
-void purple_prefs_rename_boolean_toggle(const char *oldname, const char *newname);
-
-/**
- * Remove all prefs.
- */
-void purple_prefs_destroy(void);
-
-/**
- * Set raw pref value
- *
- * @param name  The name of the pref
- * @param value The value to set
- *
- * @deprecated We're not really sure what purpose this function serves, so it
- *             will be removed in 3.0.0.  Preferences values set using this
- *             function aren't serialized to prefs.xml, which could be
- *             misleading.  There is also no purple_prefs_get_generic, which
- *             means that if you can't really get the value (other in a
- *             connected callback).  If you think you have a use for this then
- *             please let us know.
- */
-/* TODO: When this is removed, also remove struct purple_pref->value.generic */
-void purple_prefs_set_generic(const char *name, gpointer value);
-
-/**
  * Set boolean pref value
  *
  * @param name  The name of the pref
@@ -221,30 +214,6 @@
  */
 void purple_prefs_set_string(const char *name, const char *value);
 
-/**
- * Set string list pref value
- *
- * @param name  The name of the pref
- * @param value The value to set
- */
-void purple_prefs_set_string_list(const char *name, GList *value);
-
-/**
- * Set path pref value
- *
- * @param name  The name of the pref
- * @param value The value to set
- */
-void purple_prefs_set_path(const char *name, const char *value);
-
-/**
- * Set path list pref value
- *
- * @param name  The name of the pref
- * @param value The value to set
- */
-void purple_prefs_set_path_list(const char *name, GList *value);
-
 
 /**
  * Check if a pref exists
@@ -287,30 +256,6 @@
 const char *purple_prefs_get_string(const char *name);
 
 /**
- * Get string list pref value
- *
- * @param name The name of the pref
- * @return The value of the pref
- */
-GList *purple_prefs_get_string_list(const char *name);
-
-/**
- * Get path pref value
- *
- * @param name The name of the pref
- * @return The value of the pref
- */
-const char *purple_prefs_get_path(const char *name);
-
-/**
- * Get path list pref value
- *
- * @param name The name of the pref
- * @return The value of the pref
- */
-GList *purple_prefs_get_path_list(const char *name);
-
-/**
  * Returns a list of children for a pref
  *
  * @param name The parent pref
@@ -338,6 +283,11 @@
 		gpointer data);
 
 /**
+ * Call the callback of the observer
+ */
+void purple_prefs_observe(gpointer data);
+
+/**
  * Remove a callback to a pref
  */
 void purple_prefs_disconnect_callback(guint callback_id);
@@ -357,11 +307,6 @@
  */
 gboolean purple_prefs_load(void);
 
-/**
- * Rename legacy prefs and delete some that no longer exist.
- */
-void purple_prefs_update_old(void);
-
 /*@}*/
 
 #ifdef __cplusplus
Only in libpurple/protocols/bonjour: Makefile.in
Only in libpurple/protocols/bonjour: moz.build
Only in libpurple/protocols/bonjour: win32
Only in libpurple/protocols: create-cid.sh
Only in libpurple/protocols/gg: Makefile.in
Only in libpurple/protocols/gg: moz.build
Only in libpurple/protocols/jabber: Makefile.in
Only in extract/pidgin-2.10.11/libpurple/protocols/jabber: auth_cyrus.c
diff -ru extract/pidgin-2.10.11/libpurple/protocols/jabber/disco.c libpurple/protocols/jabber/disco.c
--- extract/pidgin-2.10.11/libpurple/protocols/jabber/disco.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/protocols/jabber/disco.c	2015-03-19 23:21:15.000000000 -0400
@@ -35,7 +35,9 @@
 #include "google/jingleinfo.h"
 #include "iq.h"
 #include "jabber.h"
+#ifdef USE_JINGLE
 #include "jingle/jingle.h"
+#endif
 #include "pep.h"
 #include "presence.h"
 #include "roster.h"
diff -ru extract/pidgin-2.10.11/libpurple/protocols/jabber/iq.c libpurple/protocols/jabber/iq.c
--- extract/pidgin-2.10.11/libpurple/protocols/jabber/iq.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/protocols/jabber/iq.c	2015-03-20 00:15:22.000000000 -0400
@@ -33,7 +33,9 @@
 #include "google/jingleinfo.h"
 #include "google/google_session.h"
 #include "iq.h"
+#ifdef USE_JINGLE
 #include "jingle/jingle.h"
+#endif
 #include "oob.h"
 #include "roster.h"
 #include "si.h"
@@ -43,7 +45,7 @@
 #include "ibb.h"
 
 #ifdef _WIN32
-#include "utsname.h"
+#include "win32/utsname.h"
 #endif
 
 static GHashTable *iq_handlers = NULL;
@@ -560,7 +562,9 @@
 	iq_handlers = g_hash_table_new_full(g_str_hash, g_str_equal, g_free, NULL);
 	signal_iq_handlers = g_hash_table_new_full(g_str_hash, g_str_equal, g_free, NULL);
 
+#ifdef USE_JINGLE
 	jabber_iq_register_handler("jingle", JINGLE, jingle_parse);
+#endif
 	jabber_iq_register_handler("mailbox", NS_GOOGLE_MAIL_NOTIFY,
 			jabber_gmail_poke);
 	jabber_iq_register_handler("new-mail", NS_GOOGLE_MAIL_NOTIFY,
diff -ru extract/pidgin-2.10.11/libpurple/protocols/jabber/jabber.c libpurple/protocols/jabber/jabber.c
--- extract/pidgin-2.10.11/libpurple/protocols/jabber/jabber.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/protocols/jabber/jabber.c	2015-03-20 00:15:22.000000000 -0400
@@ -69,8 +69,10 @@
 #include "pep.h"
 #include "adhoccommands.h"
 
+#ifdef USE_JINGLE
 #include "jingle/jingle.h"
 #include "jingle/rtp.h"
+#endif
 
 #define PING_TIMEOUT 60
 /* Send a whitespace keepalive to the server if we haven't sent
@@ -1597,8 +1599,10 @@
 {
 	JabberStream *js = purple_connection_get_protocol_data(gc);
 
+#ifdef USE_JINGLE
 	/* Close all of the open Jingle sessions on this stream */
 	jingle_terminate_sessions(js);
+#endif
 
 	if (js->bosh)
 		jabber_bosh_connection_close(js->bosh);
@@ -3874,8 +3878,10 @@
 	/* Bits Of Binary */
 	jabber_add_feature(NS_BOB, 0);
 
+#ifdef USE_JINGLE
 	/* Jingle features! */
 	jabber_add_feature(JINGLE, 0);
+#endif
 
 #ifdef USE_VV
 	jabber_add_feature(NS_GOOGLE_PROTOCOL_SESSION, jabber_audio_enabled);
diff -ru extract/pidgin-2.10.11/libpurple/protocols/jabber/jabber.h libpurple/protocols/jabber/jabber.h
--- extract/pidgin-2.10.11/libpurple/protocols/jabber/jabber.h	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/protocols/jabber/jabber.h	2015-03-20 00:15:22.000000000 -0400
@@ -62,8 +62,10 @@
 #include "connection.h"
 #include "dnsquery.h"
 #include "dnssrv.h"
+#ifdef USE_VV
 #include "media.h"
 #include "mediamanager.h"
+#endif
 #include "roomlist.h"
 #include "sslconn.h"
 
diff -ru extract/pidgin-2.10.11/libpurple/protocols/jabber/libxmpp.c libpurple/protocols/jabber/libxmpp.c
--- extract/pidgin-2.10.11/libpurple/protocols/jabber/libxmpp.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/protocols/jabber/libxmpp.c	2015-03-19 23:21:15.000000000 -0400
@@ -258,11 +258,11 @@
 	GList *encryption_values = NULL;
 
 	/* Translators: 'domain' is used here in the context of Internet domains, e.g. pidgin.im */
-	split = purple_account_user_split_new(_("Domain"), NULL, '@');
+	split = purple_account_user_split_new(_("Domain"), "jabber.org", '@');
 	purple_account_user_split_set_reverse(split, FALSE);
 	prpl_info.user_splits = g_list_append(prpl_info.user_splits, split);
 
-	split = purple_account_user_split_new(_("Resource"), "", '/');
+	split = purple_account_user_split_new(_("Resource"), "Instantbird", '/');
 	purple_account_user_split_set_reverse(split, FALSE);
 	prpl_info.user_splits = g_list_append(prpl_info.user_splits, split);
 
@@ -315,13 +315,6 @@
 	prpl_info.protocol_options = g_list_append(prpl_info.protocol_options,
 						  option);
 
-	/* this should probably be part of global smiley theme settings later on,
-	  shared with MSN */
-	option = purple_account_option_bool_new(_("Show Custom Smileys"),
-		"custom_smileys", TRUE);
-	prpl_info.protocol_options = g_list_append(prpl_info.protocol_options,
-		option);
-
 	my_protocol = plugin;
 
 	purple_prefs_remove("/plugins/prpl/jabber");
diff -ru extract/pidgin-2.10.11/libpurple/protocols/jabber/message.c libpurple/protocols/jabber/message.c
--- extract/pidgin-2.10.11/libpurple/protocols/jabber/message.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/protocols/jabber/message.c	2015-03-19 23:21:15.000000000 -0400
@@ -106,7 +106,8 @@
 					 * this should be able to be implemented by removing the
 					 * user from the conversation like we do with chats now. */
 					purple_conversation_write(conv, "", buf,
-					                        PURPLE_MESSAGE_SYSTEM, time(NULL));
+					                          PURPLE_MESSAGE_SYSTEM | PURPLE_MESSAGE_NO_LINKIFY,
+					                          time(NULL));
 				}
 			}
 			serv_got_typing_stopped(gc, jm->from);
@@ -602,7 +603,7 @@
 				GList *smiley_refs = NULL;
 				gchar *reformatted_xhtml;
 
-				if (purple_account_get_bool(account, "custom_smileys", TRUE)) {
+				if (purple_account_get_bool(account, "custom_smileys", FALSE)) {
 					/* find a list of smileys ("cid" and "alt" text pairs)
 					  occuring in the message */
 					smiley_refs = jabber_message_get_refs_from_xmlnode(child);
@@ -1303,5 +1304,5 @@
 	const PurpleConnection *gc = js->gc;
 	PurpleAccount *account = purple_connection_get_account(gc);
 
-	return purple_account_get_bool(account, "custom_smileys", TRUE);
+	return purple_account_get_bool(account, "custom_smileys", FALSE);
 }
Only in libpurple/protocols/jabber: moz.build
Only in libpurple/protocols: module.ver.in
Only in libpurple/protocols/msn: Makefile.in
Only in libpurple/protocols/msn: moz.build
diff -ru extract/pidgin-2.10.11/libpurple/protocols/msn/msg.c libpurple/protocols/msn/msg.c
--- extract/pidgin-2.10.11/libpurple/protocols/msn/msg.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/protocols/msn/msg.c	2015-03-20 00:15:22.000000000 -0400
@@ -819,6 +819,8 @@
 
 }
 
+#define purple_mkstemp(a, b) NULL
+
 /* TODO: Make these not be such duplicates of each other */
 static void
 got_wink_cb(MsnSlpCall *slpcall, const guchar *data, gsize size)
Only in libpurple/protocols/myspace: Makefile.in
Only in libpurple/protocols/myspace: moz.build
Only in libpurple/protocols: netsoul
Only in libpurple/protocols/novell: Makefile.in
Only in libpurple/protocols/novell: moz.build
diff -ru extract/pidgin-2.10.11/libpurple/protocols/novell/nmconn.c libpurple/protocols/novell/nmconn.c
--- extract/pidgin-2.10.11/libpurple/protocols/novell/nmconn.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/protocols/novell/nmconn.c	2015-03-19 23:21:15.000000000 -0400
@@ -19,7 +19,9 @@
  */
 
 #include <glib.h>
+#ifndef _MSC_VER
 #include <unistd.h>
+#endif
 #include <errno.h>
 #include <string.h>
 #include <ctype.h>
Only in libpurple/protocols/null: Makefile.in
Only in libpurple/protocols/null: moz.build
diff -ru extract/pidgin-2.10.11/libpurple/protocols/null/nullprpl.c libpurple/protocols/null/nullprpl.c
--- extract/pidgin-2.10.11/libpurple/protocols/null/nullprpl.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/protocols/null/nullprpl.c	2015-03-19 23:21:15.000000000 -0400
@@ -67,6 +67,9 @@
 #include "util.h"
 #include "version.h"
 
+/* Disable gettext for the null-prpl, it will never be translated... */
+#undef _
+#define _(String) (String)
 
 #define NULLPRPL_ID "prpl-null"
 static PurplePlugin *_null_protocol = NULL;
@@ -172,7 +175,8 @@
         !strcmp(status_id, NULL_STATUS_AWAY) ||
         !strcmp(status_id, NULL_STATUS_OFFLINE)) {
       purple_debug_info("nullprpl", "%s sees that %s is %s: %s\n",
-                        from_username, to_username, status_id, message);
+                        from_username, to_username, status_id,
+                        message ? message : "");
       purple_prpl_got_user_status(from->account, to_username, status_id,
                                   (message) ? "message" : NULL, message, NULL);
     } else {
@@ -364,6 +368,9 @@
 
   purple_debug_info("nullprpl", "logging in %s\n", acct->username);
 
+  if (!strcmp(acct->username, "crash@test"))
+    *((int *) NULL) = 42;
+
   purple_connection_update_progress(gc, _("Connecting"),
                                     0,   /* which connection step this is */
                                     2);  /* total number of steps */
@@ -522,8 +529,12 @@
 
 static void nullprpl_set_status(PurpleAccount *acct, PurpleStatus *status) {
   const char *msg = purple_status_get_attr_string(status, "message");
-  purple_debug_info("nullprpl", "setting %s's status to %s: %s\n",
-                    acct->username, purple_status_get_name(status), msg);
+  if (msg)
+    purple_debug_info("nullprpl", "setting %s's status to %s: %s\n",
+		      acct->username, purple_status_get_name(status), msg);
+  else
+    purple_debug_info("nullprpl", "setting %s's status to %s\n",
+		      acct->username, purple_status_get_name(status));
 
   foreach_nullprpl_gc(report_status_change, get_nullprpl_gc(acct->username),
                       NULL);
Only in libpurple/protocols/oscar: Makefile.in
diff -ru extract/pidgin-2.10.11/libpurple/protocols/oscar/authorization.c libpurple/protocols/oscar/authorization.c
--- extract/pidgin-2.10.11/libpurple/protocols/oscar/authorization.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/protocols/oscar/authorization.c	2015-03-19 23:21:15.000000000 -0400
@@ -93,12 +93,16 @@
 oscar_auth_dontgrant_msgprompt(gpointer cbdata)
 {
 	struct name_data *data = cbdata;
+#if 0
 	purple_request_input(data->gc, NULL, _("Authorization Denied Message:"),
 					   NULL, _("No reason given."), TRUE, FALSE, NULL,
 					   _("_OK"), G_CALLBACK(oscar_auth_dontgrant),
 					   _("_Cancel"), G_CALLBACK(oscar_free_name_data),
 					   purple_connection_get_account(data->gc), data->name, NULL,
 					   data);
+#else
+	oscar_auth_dontgrant(data, NULL);
+#endif
 }
 
 void
diff -ru extract/pidgin-2.10.11/libpurple/protocols/oscar/family_locate.c libpurple/protocols/oscar/family_locate.c
--- extract/pidgin-2.10.11/libpurple/protocols/oscar/family_locate.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/protocols/oscar/family_locate.c	2015-03-20 00:15:22.000000000 -0400
@@ -567,7 +567,7 @@
 aim_userinfo_t *aim_locate_finduserinfo(OscarData *od, const char *bn) {
 	aim_userinfo_t *cur = NULL;
 
-	if (bn == NULL)
+	if (bn == NULL || od == NULL)
 		return NULL;
 
 	cur = od->locate.userinfo;
diff -ru extract/pidgin-2.10.11/libpurple/protocols/oscar/libaim.c libpurple/protocols/oscar/libaim.c
--- extract/pidgin-2.10.11/libpurple/protocols/oscar/libaim.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/protocols/oscar/libaim.c	2015-03-19 23:21:15.000000000 -0400
@@ -142,10 +142,13 @@
 	NULL
 };
 
+gboolean purple_init_icq_plugin(void);
+
 static void
 init_plugin(PurplePlugin *plugin)
 {
 	oscar_init(plugin, FALSE);
+	purple_init_icq_plugin();
 }
 
-PURPLE_INIT_PLUGIN(aim, init_plugin, info);
+PURPLE_INIT_PLUGIN(oscar, init_plugin, info)
diff -ru extract/pidgin-2.10.11/libpurple/protocols/oscar/libicq.c libpurple/protocols/oscar/libicq.c
--- extract/pidgin-2.10.11/libpurple/protocols/oscar/libicq.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/protocols/oscar/libicq.c	2015-03-19 23:21:15.000000000 -0400
@@ -24,7 +24,9 @@
  * which contains all the shared implementation code with libaim
  */
 
-
+#ifndef PURPLE_STATIC_PRPL
+#define PURPLE_STATIC_PRPL
+#endif
 #include "oscarcommon.h"
 
 static GHashTable *
Only in libpurple/protocols/oscar: moz.build
diff -ru extract/pidgin-2.10.11/libpurple/protocols/oscar/oscar.c libpurple/protocols/oscar/oscar.c
--- extract/pidgin-2.10.11/libpurple/protocols/oscar/oscar.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/protocols/oscar/oscar.c	2015-03-20 00:15:22.000000000 -0400
@@ -350,7 +350,7 @@
 		flap_connection_send_version(od, conn);
 	else
 	{
-		if (purple_account_get_bool(account, "use_clientlogin", OSCAR_DEFAULT_USE_CLIENTLOGIN))
+		if (purple_account_get_bool(account, "use_clientlogin", od->icq ? ICQ_DEFAULT_USE_CLIENTLOGIN : AIM_DEFAULT_USE_CLIENTLOGIN))
 		{
 			ClientInfo aiminfo = CLIENTINFO_PURPLE_AIM;
 			ClientInfo icqinfo = CLIENTINFO_PURPLE_ICQ;
@@ -577,7 +577,7 @@
 
 	gc = data;
 	od = purple_connection_get_protocol_data(gc);
-	report_idle = strcmp((const char *)value, "none") != 0;
+	report_idle = GPOINTER_TO_INT(value);
 	presence = aim_ssi_getpresence(od->ssi.local);
 
 	if (report_idle)
@@ -765,7 +765,7 @@
 	od->use_ssl = purple_ssl_is_supported() && strcmp(encryption_type, OSCAR_NO_ENCRYPTION) != 0;
 
 	/* Connect to core Purple signals */
-	purple_prefs_connect_callback(gc, "/purple/away/idle_reporting", idle_reporting_pref_cb, gc);
+	purple_prefs_connect_callback(gc, "/messenger/status/reportIdle", idle_reporting_pref_cb, gc);
 	purple_prefs_connect_callback(gc, "/plugins/prpl/oscar/recent_buddies", recent_buddies_pref_cb, gc);
 
 	/*
@@ -778,7 +778,7 @@
 	 * This authentication method is used for both ICQ and AIM when
 	 * clientLogin is not enabled.
 	 */
-	if (purple_account_get_bool(account, "use_clientlogin", OSCAR_DEFAULT_USE_CLIENTLOGIN)) {
+	if (purple_account_get_bool(account, "use_clientlogin", od->icq ? ICQ_DEFAULT_USE_CLIENTLOGIN : AIM_DEFAULT_USE_CLIENTLOGIN)) {
 		send_client_login(od, purple_account_get_username(account));
 	} else {
 		FlapConnection *newconn;
@@ -3977,8 +3977,7 @@
 		const char *idle_reporting_pref;
 		gboolean report_idle;
 
-		idle_reporting_pref = purple_prefs_get_string("/purple/away/idle_reporting");
-		report_idle = strcmp(idle_reporting_pref, "none") != 0;
+		report_idle = purple_prefs_get_bool("/messenger/status/reportIdle");
 
 		if (report_idle)
 			aim_ssi_setpresence(od, tmp | AIM_SSI_PRESENCE_FLAG_SHOWIDLE);
@@ -4020,7 +4019,8 @@
 					b = purple_find_buddy_in_group(account, curitem->name, g);
 					if (b) {
 						/* Get server stored alias */
-						purple_blist_alias_buddy(b, alias_utf8);
+						if (!purple_strequal(curitem->name, alias_utf8))
+							purple_blist_alias_buddy(b, alias_utf8);
 					} else {
 						b = purple_buddy_new(account, curitem->name, alias_utf8);
 
@@ -5762,7 +5762,7 @@
 	prpl_info->protocol_options = g_list_append(prpl_info->protocol_options, option);
 
 	option = purple_account_option_bool_new(_("Use clientLogin"), "use_clientlogin",
-			OSCAR_DEFAULT_USE_CLIENTLOGIN);
+			is_icq ? ICQ_DEFAULT_USE_CLIENTLOGIN : AIM_DEFAULT_USE_CLIENTLOGIN);
 	prpl_info->protocol_options = g_list_append(prpl_info->protocol_options, option);
 
 	option = purple_account_option_bool_new(
diff -ru extract/pidgin-2.10.11/libpurple/protocols/oscar/oscarcommon.h libpurple/protocols/oscar/oscarcommon.h
--- extract/pidgin-2.10.11/libpurple/protocols/oscar/oscarcommon.h	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/protocols/oscar/oscarcommon.h	2015-03-19 23:21:15.000000000 -0400
@@ -54,7 +54,8 @@
 #define OSCAR_DEFAULT_WEB_AWARE FALSE
 #define OSCAR_DEFAULT_ALWAYS_USE_RV_PROXY FALSE
 #define OSCAR_DEFAULT_ALLOW_MULTIPLE_LOGINS TRUE
-#define OSCAR_DEFAULT_USE_CLIENTLOGIN TRUE
+#define AIM_DEFAULT_USE_CLIENTLOGIN FALSE
+#define ICQ_DEFAULT_USE_CLIENTLOGIN TRUE
 #define OSCAR_DEFAULT_ENCRYPTION OSCAR_OPPORTUNISTIC_ENCRYPTION
 
 #ifdef _WIN32
Only in libpurple/protocols: prpl-rules.mk
Only in libpurple/protocols: prpl.mk
Only in libpurple/protocols: prpl.py
Only in libpurple/protocols: qq
Only in libpurple/protocols/sametime: Makefile.in
Only in libpurple/protocols/sametime: meanwhile
Only in libpurple/protocols/sametime: moz.build
diff -ru extract/pidgin-2.10.11/libpurple/protocols/sametime/sametime.c libpurple/protocols/sametime/sametime.c
--- extract/pidgin-2.10.11/libpurple/protocols/sametime/sametime.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/protocols/sametime/sametime.c	2015-03-20 00:15:22.000000000 -0400
@@ -927,11 +927,6 @@
     return NULL;
   }
 
-  if (!name) {
-    DEBUG_WARN("Can't ensure a null group\n");
-    return NULL;
-  }
-
   DEBUG_INFO("attempting to ensure group %s, called %s\n",
 	     NSTR(name), NSTR(alias));
 
Only in libpurple/protocols/simple: Makefile.in
Only in libpurple/protocols/simple: moz.build
Only in libpurple/protocols: sipe
Only in libpurple/protocols: xpcomModule.cpp.in
Only in libpurple/protocols/yahoo: Makefile.in
diff -ru extract/pidgin-2.10.11/libpurple/protocols/yahoo/libyahoo.c libpurple/protocols/yahoo/libyahoo.c
--- extract/pidgin-2.10.11/libpurple/protocols/yahoo/libyahoo.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/protocols/yahoo/libyahoo.c	2015-03-19 23:21:15.000000000 -0400
@@ -306,6 +306,8 @@
 	NULL
 };
 
+gboolean purple_init_yahoojp_plugin(void);
+
 static void
 init_plugin(PurplePlugin *plugin)
 {
@@ -343,6 +345,7 @@
 
 	purple_signal_connect(purple_get_core(), "uri-handler", plugin,
 		PURPLE_CALLBACK(yahoo_uri_handler), NULL);
+	purple_init_yahoojp_plugin();
 }
 
 PURPLE_INIT_PLUGIN(yahoo, init_plugin, info);
diff -ru extract/pidgin-2.10.11/libpurple/protocols/yahoo/libyahoojp.c libpurple/protocols/yahoo/libyahoojp.c
--- extract/pidgin-2.10.11/libpurple/protocols/yahoo/libyahoojp.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/protocols/yahoo/libyahoojp.c	2015-03-19 23:21:15.000000000 -0400
@@ -21,6 +21,9 @@
  *
  */
 
+#ifndef PURPLE_STATIC_PRPL
+#define PURPLE_STATIC_PRPL
+#endif
 #include "internal.h"
 
 #include <account.h>
diff -ru extract/pidgin-2.10.11/libpurple/protocols/yahoo/libymsg.c libpurple/protocols/yahoo/libymsg.c
--- extract/pidgin-2.10.11/libpurple/protocols/yahoo/libymsg.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/protocols/yahoo/libymsg.c	2015-03-20 00:15:22.000000000 -0400
@@ -1363,12 +1363,15 @@
 static void
 yahoo_buddy_add_deny_reason_cb(gpointer data) {
 	struct yahoo_add_request *add_req = data;
+	yahoo_buddy_add_deny_cb(add_req, NULL);
+	/*
 	purple_request_input(add_req->gc, NULL, _("Authorization denied message:"),
 			NULL, _("No reason given."), TRUE, FALSE, NULL,
 			_("OK"), G_CALLBACK(yahoo_buddy_add_deny_cb),
 			_("Cancel"), G_CALLBACK(yahoo_buddy_add_deny_noreason_cb),
 			purple_connection_get_account(add_req->gc), add_req->who, NULL,
 			add_req);
+	*/
 }
 
 static void yahoo_buddy_denied_our_add(PurpleConnection *gc, const char *who, const char *reason)
Only in libpurple/protocols/yahoo: moz.build
diff -ru extract/pidgin-2.10.11/libpurple/protocols/yahoo/util.c libpurple/protocols/yahoo/util.c
--- extract/pidgin-2.10.11/libpurple/protocols/yahoo/util.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/protocols/yahoo/util.c	2015-03-20 00:15:22.000000000 -0400
@@ -499,11 +499,13 @@
 			 */
 			int size, htmlsize;
 			gchar tmp[11];
+			gchar *tmp2 = g_strdup_printf("font-size: %spt", fontsize);
 			size = strtol(fontsize, NULL, 10);
 			htmlsize = point_to_html(size);
 			sprintf(tmp, "%u", htmlsize);
 			xmlnode_set_attrib(*cur, "size", tmp);
-			xmlnode_set_attrib(*cur, "absz", fontsize);
+			xmlnode_set_attrib(*cur, "style", tmp2);
+			g_free(tmp2);
 #endif /* !USE_CSS_FORMATTING */
 			g_free(fontsize);
 		}
diff -ru extract/pidgin-2.10.11/libpurple/proxy.c libpurple/proxy.c
--- extract/pidgin-2.10.11/libpurple/proxy.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/proxy.c	2015-03-20 00:15:22.000000000 -0400
@@ -285,6 +285,7 @@
 	return param;
 }
 
+#if 0
 static PurpleProxyInfo *
 purple_gnome_proxy_get_info(void)
 {
@@ -415,6 +416,7 @@
 
 	return &info;
 }
+#endif
 
 #ifdef _WIN32
 
@@ -2236,9 +2238,11 @@
 			gpi = NULL;
 	}
 	if (gpi == NULL) {
+#if 0
 		if (purple_running_gnome())
 			gpi = purple_gnome_proxy_get_info();
 		else
+#endif
 			gpi = purple_global_proxy_get_info();
 	}
 
@@ -2560,6 +2564,7 @@
 	}
 }
 
+#if 0
 static void
 proxy_pref_cb(const char *name, PurplePrefType type,
 			  gconstpointer value, gpointer data)
@@ -2595,6 +2600,7 @@
 	else if (purple_strequal(name, "/purple/proxy/password"))
 		purple_proxy_info_set_password(info, value);
 }
+#endif
 
 void *
 purple_proxy_get_handle()
@@ -2614,13 +2620,16 @@
 
 	/* Proxy */
 	purple_prefs_add_none("/purple/proxy");
+#if 0
 	purple_prefs_add_string("/purple/proxy/type", "none");
 	purple_prefs_add_string("/purple/proxy/host", "");
 	purple_prefs_add_int("/purple/proxy/port", 0);
 	purple_prefs_add_string("/purple/proxy/username", "");
 	purple_prefs_add_string("/purple/proxy/password", "");
+#endif
 	purple_prefs_add_bool("/purple/proxy/socks4_remotedns", FALSE);
 
+#if 0
 	/* Setup callbacks for the preferences. */
 	handle = purple_proxy_get_handle();
 	purple_prefs_connect_callback(handle, "/purple/proxy/type", proxy_pref_cb,
@@ -2640,6 +2649,7 @@
 	purple_prefs_trigger_callback("/purple/proxy/port");
 	purple_prefs_trigger_callback("/purple/proxy/username");
 	purple_prefs_trigger_callback("/purple/proxy/password");
+#endif
 }
 
 void
diff -ru extract/pidgin-2.10.11/libpurple/proxy.h libpurple/proxy.h
--- extract/pidgin-2.10.11/libpurple/proxy.h	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/proxy.h	2015-03-19 23:21:15.000000000 -0400
@@ -195,6 +195,13 @@
  */
 void purple_global_proxy_set_info(PurpleProxyInfo *info);
 
+/**
+ * Set purple's global proxy information.
+ *
+ * @param info     The proxy information.
+ */
+void purple_global_proxy_set_info(PurpleProxyInfo *info);
+
 /*@}*/
 
 /**************************************************************************/
diff -ru extract/pidgin-2.10.11/libpurple/prpl.c libpurple/prpl.c
--- extract/pidgin-2.10.11/libpurple/prpl.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/prpl.c	2015-03-20 00:15:22.000000000 -0400
@@ -382,6 +382,9 @@
 	g_return_if_fail(new_status != NULL);
 	g_return_if_fail(!purple_status_is_exclusive(new_status) || old_status != NULL);
 
+	purple_signal_emit(purple_accounts_get_handle(), "account-status-changing",
+					account, old_status, new_status);
+
 	do_prpl_change_account_status(account, old_status, new_status);
 
 	purple_signal_emit(purple_accounts_get_handle(), "account-status-changed",
